#include <iostream>
#include <sstream>
#include <list>
#include <cstring>
#include "csprng.h"
using namespace std;

int test(const int count) {
	const int LEN = 512;
	char seed[LEN];
	csprng::generateSeed(seed, LEN);
	csprng* rnd1 = new csprng(seed, LEN);
	csprng* rnd2 = new csprng(seed, LEN);
	
	for (int i = 0; i < count; ++i) {
		char r1, r2;
		rnd1->getRandom(&r1, sizeof(r1));
		rnd2->getRandom(&r2, sizeof(r2));
		if (r1 != r2) {
			cout << i << ": " << r1 << " != " << r2 << endl;
			return 1;
		}
	}
	cout << "OK." << endl;
	return 0;
}

#define LEN 12288000

int main(int argc, char* argv[]) {
	if (argc == 1) {
		cout << "Usage: " << argv[0] << " --test [count]\n"
			 << "   or: " << argv[0] << " NumberOfRandomBytes"
			 << endl;
		return 0;
	}
	if (strcmp(argv[1], "--test") == 0) {
		int count = 100000;
		if (argc > 2) {
			stringstream ss(argv[2]);
			ss >> count;
		}
		return test(count);
	}
	csprng* rnd = new csprng();
	unsigned int N;
	stringstream(argv[1]) >> N;
	unsigned int count = N / LEN;
	unsigned int mod = N % LEN;
	char* buf = new char[LEN];
	for	(int i = 0; i < count; ++i) {
		rnd->getRandom(buf, LEN);
		cout.write(buf, LEN);
	}
	if (mod != 0) {
		rnd->getRandom(buf, mod);
		cout.write(buf, mod);
	}
	delete buf;
	delete rnd;
}
